<script setup lang="ts">
    import { computed } from 'vue'
    import SDateField from './SDateField.vue'
    import SDateTimeField from './SDateTimeField.vue'
    import { isDefined, isUndefined } from '@/shared/helpers/types'

    interface Props {
        isRequired?: boolean
        useTime?: boolean
        labelDateDeDebut?: string
        labelDateDeFin?: string
    }

    withDefaults(defineProps<Props>(), {
        isRequired: false,
        useTime: false,
        labelDateDeDebut: 'Date de début',
        labelDateDeFin: 'Date de fin',
    })

    const dateDeDebut = defineModel<Date | undefined>('dateDeDebut', {
        required: true,
    })
    const dateDeFin = defineModel<Date | undefined>('dateDeFin', {
        required: true,
    })

    const rules = {
        hasDateDeDebut: (input: Date | undefined) => {
            return isDefined(input) || 'La date de début est obligatoire.'
        },
        hasDateDeFin: (input: Date | undefined) => {
            return isDefined(input) || 'La date de fin est obligatoire.'
        },
    }

    const messageDErreurSiDateDeFinPlusGrandeQueDateDeDebut = computed(() => {
        if (isUndefined(dateDeDebut.value) || isUndefined(dateDeFin.value)) {
            return []
        }

        return dateDeDebut.value > dateDeFin.value
            ? ['La date de fin doit être supérieure à la date de début']
            : []
    })
</script>

<template>
    <v-col cols="12" sm="6">
        <s-date-time-field
            v-if="useTime"
            v-model="dateDeDebut"
            :label="labelDateDeDebut + (isRequired ? '*' : '')"
            hide-details="auto"
            data-cy="date-de-debut"
            :rules="isRequired ? [rules.hasDateDeDebut] : []"
            :error-messages="messageDErreurSiDateDeFinPlusGrandeQueDateDeDebut"
            :clearable="!isRequired"
        />
        <s-date-field
            v-else
            v-model="dateDeDebut"
            :label="labelDateDeDebut + (isRequired ? '*' : '')"
            hide-details="auto"
            data-cy="date-de-debut"
            :rules="isRequired ? [rules.hasDateDeDebut] : []"
            :error-messages="messageDErreurSiDateDeFinPlusGrandeQueDateDeDebut"
            :clearable="!isRequired"
        />
    </v-col>
    <v-col cols="12" sm="6">
        <s-date-time-field
            v-if="useTime"
            v-model="dateDeFin"
            :label="labelDateDeFin + (isRequired ? '*' : '')"
            hide-details="auto"
            data-cy="date-de-fin"
            :rules="isRequired ? [rules.hasDateDeDebut] : []"
            :error-messages="messageDErreurSiDateDeFinPlusGrandeQueDateDeDebut"
            :clearable="!isRequired"
        />
        <s-date-field
            v-else
            v-model="dateDeFin"
            :label="labelDateDeFin + (isRequired ? '*' : '')"
            hide-details="auto"
            data-cy="date-de-fin"
            :rules="isRequired ? [rules.hasDateDeDebut] : []"
            :error-messages="messageDErreurSiDateDeFinPlusGrandeQueDateDeDebut"
            :clearable="!isRequired"
        />
    </v-col>
</template>
